#include <stdio.h>
#include <math.h>
#define nn 5000
double pi,cx,cy;
float z1[nn],xx[nn],yy[nn],rr[nn],dd[nn],z2[nn];  // 1st *.cat value
float z3[nn];
char  cc[nn];                                  // cc[] matched, z2[]=2nd's mag 
char  f1[30],f2[30];
int   n;                                    // 1st length
float u=1.;                                 // max match err, in second.
FILE  *fp;
main(int ac,char **av)
{
  int i,j,k;
  char a[80];
  float z,x,y,r,d;
  float v,cosd;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  if(ac<3){ printf("\n\t *** ccd3 linary ****\n\n");
            printf("\n\t Usage: ccd3 b160.cat b161.cat\n");
            printf("\n\t before: sex p7041g0160_3.fit (uefault.sex)");
            printf("\n\t         mv test.cat a160.cat");
    printf("\n\t         bok_xy2ad1 p7041g0160_3.fit a160.cat ! >b160.cat\n\n");
    exit(0);
  }
  strcpy(f1,av[1]);
  fp=fopen(f1,"r"); if(!fp){ printf("%s not found!\n",f1); exit(0); }
  fgets(a,80,fp); a[strlen(a)-1]=0; strcpy(f1,&a[2]);  
  n=0;
l10:
  fgets(a,80,fp); if(feof(fp))goto l20;
  sscanf(a,"%f %f %f %f %f",&z1[n],&xx[n],&yy[n],&rr[n],&dd[n]);
  cc[n]=0; n++;
  if(n<nn)goto l10;
l20:
  fclose(fp);
  cosd=cos(dd[n/2]*cy);
  strcpy(f2,av[2]);
  fp=fopen(f2,"r"); if(!fp){ printf("%s not found!\n",f2); exit(0); }
  fgets(a,80,fp); 
l30:
  fgets(a,80,fp); if(feof(fp))goto l40;
  sscanf(a,"%f %f %f %f %f",&z,&x,&y,&r,&d);
  v=u;
  for(i=0;i<n;i++){
    y=d-dd[i]; y*=3600.;       y=y*y; if(y>v)continue;
    x=r-rr[i]; x*=cosd*54000.; x=x*x; if(x>v)continue;
    x+=y;                             if(x>v)continue;
    v=x; cc[i]=1; z2[i]=z; 
  }
  goto l30;
l40:
  fclose(fp);
//--------------
  k=0; for(i=0;i<n;i++)if(cc[i]){ z3[k++]=z1[i]-z2[i]; }
  mean(z3,k,&x,&y);
  for(i=0;i<n;i++)if(cc[i])z2[i]+=x;      // -bias
  for(i=k=0;i<n;i++)if(cc[i]){
    z2[k]=z1[i]-z2[i]; xx[k]=xx[i]; yy[k]=yy[i]; z1[k]=z1[i];
//    printf("%3d: %7.1f %7.1f %6.2f %6.2f\n",k+1,xx[k],yy[k],z1[k],z2[k]);
    k++;
  }
  sortx1(k,xx,yy,z1,z2);
  for(i=0;i<k;i++)
    printf("%3d: %7.1f %7.1f %6.2f %6.2f\n",i+1,xx[i],yy[i],z1[i],z2[i]);
  printf("# matched: %d/%d  mean: %f sig: %f\n",k,n,x,y);
}

sortx1(n,x1,x2,x3,x4)
int n; float *x1,*x2,*x3,*x4;
{
  int i,j,k=2,ii,ifin; float y1,y2,y3,y4;
  while(k<n)k*=2;
  k=(3*k)/4-1; if(n<k)k=n;
l20:
  k/=2;        ifin=n-k;
  for(ii=0;ii<ifin;ii++){
    i=ii;      j=i+k;
    if(x1[i]<=x1[j])continue;
    y1=x1[j]; y2=x2[j]; y3=x3[j]; y4=x4[j];
l40:
    x1[j]=x1[i]; x2[j]=x2[i]; x3[j]=x3[i]; x4[j]=x4[i];
    j=i;       i-=k;
    if(i<0)goto l60;
    if(x1[i]>y1)goto l40;
l60:
    x1[j]=y1; x2[j]=y2; x3[j]=y3; x4[j]=y4;
  }
  if(k>1)goto l20;
}

mean(yy,n,xx,sig)                            // delete 3 sigma point
float *yy; int n; float *xx,*sig;
{
  int i,j,k; float x,y,z; char m[nn];
  for(i=0;i<n;i++)m[i]=1;
l10:
  x=0.; k=0; for(i=0;i<n;i++)if(m[i]){ k++; x+=yy[i]; } x/=k;
  z=0.; for(i=0;i<n;i++)if(m[i])z+=(yy[i]-x)*(yy[i]-x); z=sqrt(z/k);
  for(i=j=0;i<n;i++)if(m[i]){
    y=yy[i]-x; if(y<0.)y=-y; if(y>3.*z){ m[i]=0; j++; }
  }
  if(j)goto l10;
  *xx=x;
  *sig=z;
}


